<?php
namespace Ma\Web;

use Ma\Sys\Dbg;
use Ma\App;
use Ma\Web\AbstractController;
use Twig\Environment;

/**
 * @package         Ma\Web
 * @class           WebController
 * @extends         AbstractController
 * @author          Mahdi Abu Yasmine
 * @date            2024-02-17 03:00:29 CET
 * @copyright       meta-tech.academy
 */
class WebController extends AbstractController
{

    protected Environment $tpl;
    protected App         $app;

    /**
     * @inherit
     */
    public function init(App $app)
    {
        $this->app = $app;
        $this->tpl = $app['tpl']("default");
    }

    /**
     * get the specifiyed post params in a uniq assoc array
     * use extract to get back the var wich is automatically loaded in current context (scope)
     *
     * @public
     * @param       array   $data
     * @return      array
     */
    public function params($data){
        foreach($data as $param){
            $$param = $_POST[$param];
        }
        return compact($data);
    }

    /**
     * get the specified post param
     *
     * @public
     * @param       string  $name
     * @param       string  $defaultValue
     * @return      string
     */
    public function param($name, $defaultValue='') {
        return $_POST[$name] ?: $defaultValue;
    }

    /**
     * get the specified get param
     *
     * @public
     * @param       string  $name
     * @param       string  $defaultValue
     * @return      string
     */
    public function query($name, $defaultValue='') {
        return $_GET[$name] ?: $defaultValue;
    }

    /**
     * @inherit
     */
    public function connect(): array
    {
        return [];
    }

}
